import numpy as np
import matplotlib.pyplot as plt

class visLocGlobError:
    def __init__(self,x0=0,y0=1,h=0.5,n=5,nplot=300):
        self.h = h
        self.xEnd = x0+n*h
        self.xp = np.linspace(x0,self.xEnd,nplot)
        self.x0 = x0
        self.y0 = y0
        self.xi = [x0]
        self.yi = [y0]
        x = x0
        while x < self.xEnd:
            self.yi.append(self.yi[-1] + h*self.yi[-1])
            self.xi.append(self.xi[-1] + h)
            x += h

    def y(self, x, x0, y0):
        return y0*np.exp(x-x0)

    def visualizeStep(self,k):
        plt.figure(figsize=(6,6))
        plt.plot(self.xp, self.y(self.xp, self.x0, self.y0))
        plt.plot(self.xi, self.yi, 'o')
        plt.plot(self.xp, self.y(self.xp, self.xi[k-1], self.yi[k-1]), alpha=0.25)
        xpk = self.xp[(self.xi[k-1]<=self.xp)*(self.xp <= self.xi[k])]
        plt.plot(xpk, self.y(xpk, self.xi[k-1], self.yi[k-1]))
        plt.plot([self.xi[k],self.xi[k]+2*self.h/5],
                 [self.yi[k], self.yi[k]], c='gray', linewidth=1,)
        plt.plot([self.xi[k],self.xi[k]+2*self.h/5],
                 [self.y(self.xi[k], self.x0, self.y0), self.y(self.xi[k], self.x0, self.y0)], c='gray', linewidth=1,)
        plt.plot([self.xi[k],self.xi[k]+self.h/5],
                 [self.y(self.xi[k], self.xi[k - 1], self.yi[k - 1]),self.y(self.xi[k], self.xi[k - 1], self.yi[k - 1])], c='gray', linewidth=1,)
        plt.plot([self.xi[k]+self.h/5,self.xi[k]+self.h/5],
                 [self.yi[k],self.y(self.xi[k], self.xi[k - 1], self.yi[k - 1])], c='green',label='lokaler Fehler')
        plt.plot([self.xi[k]+2*self.h/5,self.xi[k]+2*self.h/5],
                 [self.yi[k],self.y(self.xi[k], self.x0, self.y0)], c='red',label='globaler Fehler')
        plt.legend(loc=0)
        plt.xlabel('x')
        plt.ylabel('y')
        plt.title('Schritt: '+str(k))
        plt.ylim(0,13)
        plt.xlim(0,3)
        plt.gca().set_aspect(3/13)
        plt.tight_layout()
        plt.show()

if __name__ == "__main__":
    vis = visLocGlobError()

    vis.visualizeStep(3)
